#define _GNU_SOURCE
#include <pthread.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <err.h>
#include <time.h>
#include <sched.h>
#include <unistd.h>
#include <sys/ioctl.h>

#define SYSCHK(x) ({          \
  typeof(x) __res = (x);      \
  if (__res == (typeof(x))-1) \
    err(1, "SYSCHK(" #x ")"); \
  __res;                      \
})

static int devfd;
static time_t start_time;

void pin_to(int core) {
	cpu_set_t cpu_set;
	CPU_ZERO(&cpu_set);
	CPU_SET(core, &cpu_set);
	SYSCHK(sched_setaffinity(0, sizeof(cpu_set_t), &cpu_set));
}

static void *thread_fn(void *dummy) {
	pin_to(1);
	while (time(NULL) < start_time) /*spin*/;
	errno = 0;
	int res = ioctl(devfd, 0x13370002, 0);
	printf("thread 2: %d (%m)\n", res);
	return NULL;
}

int main(void) {
	sync();

	devfd = SYSCHK(open("/dev/xen_cmpxchg_abac", O_RDWR));
	start_time = time(NULL)+2;

	pthread_t thread;
	if (pthread_create(&thread, NULL, thread_fn, NULL))
		errx(1, "pthread_create");

	pin_to(0);
	while (time(NULL) < start_time) /*spin*/;
	int res = ioctl(devfd, 0x13370001, 0);
	printf("thread 1: %d (%m)\n", res);
	if (pthread_join(thread, NULL))
		errx(1, "pthread_join");
	return 0;
}
